/*  v 3.01,  16F628a,    ISL1208,  Clover M269
              AD7414-0*/
/*clock go*/
/* SC, MN, HR, DT, MO, YR, DW         */
/*  */
/*       
  
   SETUP   
  
   ()        ()
    30 
(    ,     - 
3.00
        
3.01
  
*/
        unsigned char SC, MN, HR, DT, MO, YR, DW;
        unsigned char DW1, DW2, DW3;
        unsigned char SC1, MN1, HR1, DT1, YR1;
        unsigned char SC10, MN10, HR10, DT10, YR10;
        unsigned char MO1, MO2, MO3;
        unsigned char STAT, PARAMETR, BPORT;

        unsigned char Puls;  //     
        unsigned char CONTRAST, CONTR_VAL;
        unsigned char TEMP0;       // 
        char TEMP1;
        unsigned char ZNAK, T1, T10;
        unsigned char MODE;         //  000 -  , 001 -  
        unsigned char MEAS_TEMP;    // 
        unsigned char FLAG_EXIT;    //     0x01 -     
        signed char CORR; //  
        unsigned char ZNAK_CORR;
// Software I2C connections
sbit Soft_I2C_Scl           at RB3_bit;
sbit Soft_I2C_Sda           at RB1_bit;
sbit Soft_I2C_Scl_Direction at TRISB3_bit;
sbit Soft_I2C_Sda_Direction at TRISB1_bit;
// End Software I2C connections

void Write_Time(unsigned char MN_set, unsigned char HR_set, unsigned char DW_set,
                unsigned char DT_set, unsigned char MO_set, unsigned char YR_set)
     {

     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x01);
     Soft_I2C_Write(MN_set);            //
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x02);
     Soft_I2C_Write(HR_set|0x80);    //, 24- 
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x03);
     Soft_I2C_Write(DT_set);           //
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x04);
     Soft_I2C_Write(MO_set);         //
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x05);
     Soft_I2C_Write(YR_set);         //
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x06);
     Soft_I2C_Write(DW_set);         //  SUN
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x08);
     Soft_I2C_Write(0x09);           //INT, 2 
     Soft_I2C_Stop();                // Issue stop signal


     Soft_I2C_Start();               // Issue start signal
     Soft_I2C_Write(0xDE);           // Address ISL1208
     Soft_I2C_Write(0x0A);           //address of  register (0x0A) (ATR)
     Soft_I2C_Write(0x20);           //ATR
     Soft_I2C_Write(0x04);           //DTR
     Soft_I2C_Stop();                // Issue stop signal
     }

void interrupt()
     {if (INTF_bit)                          //  RTC
         {INTF_bit = 0;
         Puls++;
         if (Puls > 0x3B)
            {if (PARAMETR != 0x00)
                {FLAG_EXIT = 0x01;     //   
                PARAMETR = 0x00;     //  30 c       
                }

            MEAS_TEMP = 0x01;     //  
            Puls = 0x00;
            }
         }
     
     if (RBIF_bit)
        {Delay_ms(100);
        BPORT = PORTB;
        RBIF_bit = 0;
        Puls = 0x00;                          //     
        if (!RB7_bit&&RB6_bit&&RB5_bit)                                                       //push S1 ()
           {MODE = 0x00;                                       //     -   
            if (PARAMETR == 0x00) PARAMETR = 0x09; //    
                   else if (PARAMETR == 0x0A) PARAMETR = 0x01;
                           else if (PARAMETR == 0x08)
                                   {PARAMETR = 0x00; //   
                                   FLAG_EXIT = 0x01;
                                   }
                                   else ++ PARAMETR;  //    
           

           }
        if (!RB6_bit&&(PARAMETR!=0x00)&&RB7_bit&&RB5_bit)                                         //push S2 ()
           {switch(PARAMETR) {
                          case 0x05: if ((HR&0x7F)==0x00) HR = 0x23;
                                        else {--HR; if ((HR&0x0F)>9) HR = (HR&0xF0)+9;};      //decrement of hours
                                     break;
                          case 0x06: if (MN10==0x00) MN10 = 0x05; else --MN10;                //decrement of minutes
                                     break;
                          case 0x07: if (MN1==0x00) MN1 = 0x09; else --MN1;                  //decrement of minutes
                                     break;
                          case 0x08: //SC = 0x00;                       //zeroizing of seconds
                                     PARAMETR = 0x0B;
                                     FLAG_EXIT = 0x01;     //   
                                     break;
                          case 0x04: --DW; if (DW == 0xFF) DW = 0x06;
                                     break;
                          case 0x03: if (DT==0x01) DT = 0x31;
                                        else {--DT; if ((DT&0x0F)>9) DT = (DT&0xF0)+9;};     //decrement of date
                                     break;
                          case 0x02: if (MO==0x01) MO = 0x12;
                                        else {--MO; if ((MO&0x0F)>9) MO = (MO&0xF0)+9;};      //decrement of date
                                     break;
                          case 0x01: if (YR==0x00) YR = 0x99;
                                        else {--YR; if ((YR&0x0F)>9) YR = (YR&0xF0)+9;};      //decrement of date
                                     break;
                          case 0x09:if (CONTRAST==0x90) CONTRAST = 0x9F; else --CONTRAST;
                                    if (CONTR_VAL==0x30) CONTR_VAL = 0x46;
                                        else if (CONTR_VAL==0x41) CONTR_VAL = 0x39;
                                             else --CONTR_VAL;
                                    break;
                          case 0x0A: --CORR; //  
                                     if (CORR < -9) CORR = -9;
                                             
                               }
           MN = MN1+(MN10<<4);               //    
           }
           
           if (!RB6_bit&&(PARAMETR==0x00)&&RB7_bit&&RB5_bit)                                //push S2 ()    
              MODE = MODE^0x01; // 
           if (!RB5_bit&&(PARAMETR!=0x00)&&RB7_bit&&RB6_bit)                                //push S3
           {switch(PARAMETR) {
                          case 0x05: if (HR==0x23) HR = 0x00;
                                        else {++HR; if ((HR&0x0F)>9) HR = (HR&0xF0)+0x10;}; //increment of hours
                                     break;
                          case 0x06: if (MN10==0x05) MN10 = 0x00; else ++MN10;              //increment of minutes
                                     break;
                          case 0x07: if (MN1==0x09) MN1 = 0x00; else ++MN1;                 //increment of minutes
                                     break;
                          case 0x08: //SC = 0x00;                                             //zeroizing of seconds
                                     PARAMETR = 0x0B;
                                     FLAG_EXIT = 0x01;     //   
                                     break;
                          case 0x04: ++DW; if (DW == 7) DW = 0x00;
                                     break;
                          case 0x03: if (DT==0x31) DT = 0x01;
                                        else {++DT; if ((DT&0x0F)>9) DT = (DT&0xF0)+0x10;}; //increment of date
                                     break;
                          case 0x02: if (MO==0x12) MO = 0x01;
                                        else {++MO; if ((MO&0x0F)>9) MO = (MO&0xF0)+0x10;};      //increment of date
                                     break;
                          case 0x01: if (YR==0x99) YR = 0x00;
                                        else {++YR; if ((YR&0x0F)>9) YR = (YR&0xF0)+0x10;};      //decrement of date
                                     break;
                          case 0x09:if (CONTRAST==0x9F) CONTRAST = 0x90; else ++CONTRAST;
                                    if (CONTR_VAL==0x46) CONTR_VAL = 0x30;
                                        else if (CONTR_VAL==0x39) CONTR_VAL = 0x41;
                                             else ++CONTR_VAL;
                                    break;
                          case 0x0A: ++CORR;  //  
                                     if (CORR > 9) CORR = 9;
                                        }
              MN = MN1+(MN10<<4);               //    
             }
             if (!RB5_bit&&(PARAMETR==0x00)&&RB7_bit&&RB6_bit)                                      //push S3    
                if (MODE == 0x00) MODE = 0x01; else MODE = 0x00; // 
           if (CORR < 0) ZNAK_CORR = '-'; else ZNAK_CORR = '+';
           }
     }

void IndicatorSet()
{/* ******************************************************************************** */
/* *********************************  ***************************** */
/* ******************************************************************************** */

                   Soft_I2C_Start();                            // Issue start signal 1
                   Soft_I2C_Write(0x76);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x34);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x0C);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x06);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x35);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0xFF);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(CONTRAST);   //  -   0  F
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x03);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x04);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x08);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x34);
                   Soft_I2C_Stop();                               // Issue stop signal 1

                   Soft_I2C_Start();                              // Issue start signal 2
                   Soft_I2C_Write(0x76);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x40);
                   if ((PARAMETR == 0x05)&&((Puls&0x01)==0x00))                                     //5
                      {Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);}
                        else {if (HR10 == 0x00) {Soft_I2C_Write(0x20);Soft_I2C_Write(HR1+0x30);}
                                 else {Soft_I2C_Write(HR10+0x30);Soft_I2C_Write(HR1+0x30);}
                             }
                   if (((Puls&0x01)==0x01)&&(PARAMETR == 0x00)&&(MODE == 0x01)) Soft_I2C_Write(0x20); else Soft_I2C_Write(0x3A); // 
                   if ((PARAMETR == 0x06)&&((Puls&0x01)==0x00)) Soft_I2C_Write(0x20);
                        else Soft_I2C_Write(MN10+0x30);
                   if ((PARAMETR == 0x07)&&((Puls&0x01)==0x00)) Soft_I2C_Write(0x20);
                        else Soft_I2C_Write(MN1+0x30);
                   if (MODE == 0x00)
                      {if ((PARAMETR == 0x08)&&((Puls&0x01)==0x00))
                         {Soft_I2C_Write(SC10|(0xE0)); Soft_I2C_Write(SC1|(0xE0));}      //10
                               else {Soft_I2C_Write(SC10+0x30);Soft_I2C_Write(SC1+0x30);}
                      Soft_I2C_Write(0x20);
                      Soft_I2C_Write(0x20);
                      }
                   if (MODE == 0x01)
                      {//if (T10 == 0x00) {Soft_I2C_Write(0x20);
                       //                 Soft_I2C_Write(ZNAK);
                       //                 }
                       //                 else {Soft_I2C_Write(ZNAK);//10
                       //                      Soft_I2C_Write(T10+0x30);
                       //                      }
                      Soft_I2C_Write(ZNAK);//10
                      Soft_I2C_Write(T10+0x30);
                      
                      Soft_I2C_Write(T1+0x30);
                      Soft_I2C_Write(0xDF);
                      Soft_I2C_Write(0x43);
                      }
                   if ((PARAMETR == 0x09)&&((Puls&0x01)==0x01)) Soft_I2C_Write(CONTR_VAL); //14
                      else if (MODE == 0x00) Soft_I2C_Write(0x20);
                      
                   if ((PARAMETR == 0x0A)&&((Puls&0x01)==0x01)) 
                                 {Soft_I2C_Write(ZNAK_CORR);
                                  if (CORR >= 0) Soft_I2C_Write(CORR+0x30); else Soft_I2C_Write(0x30 - CORR);
                                 }
                      else if (MODE == 0x00) {Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);}

                   Soft_I2C_Stop();                               // Issue stop signal 2

                   Soft_I2C_Start();                              // Issue start signal 3
                   Soft_I2C_Write(0x76);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0xC0);
                   Soft_I2C_Write(0x40);
                   if ((PARAMETR == 0x03)&&((Puls&0x01)==0x00))
                      {Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);}
                        else {Soft_I2C_Write(DT10+0x30);Soft_I2C_Write(DT1+0x30);} //5
                   Soft_I2C_Write(0x20);
                   if ((PARAMETR == 0x02)&&((Puls&0x01)==0x00))                   //7
                      {Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);}      //10
                        else {Soft_I2C_Write(MO1);Soft_I2C_Write(0x20);Soft_I2C_Write(MO2);Soft_I2C_Write(MO3);}
                   if ((PARAMETR == 0x04)&&((Puls&0x01)==0x00))
                      {Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);Soft_I2C_Write(0x20);}
                        else {Soft_I2C_Write(DW1);Soft_I2C_Write(DW2);Soft_I2C_Write(DW3);}
                   if ((PARAMETR == 0x01)&&((Puls&0x01)==0x00))
                      {Soft_I2C_Write(0x20); Soft_I2C_Write(0x20);}
                        else {Soft_I2C_Write(YR10+0x30);Soft_I2C_Write(YR1+0x30);}
                   Soft_I2C_Stop();                               // Issue stop signal 3

                   Soft_I2C_Start();                              // Issue start signal 4
                   Soft_I2C_Write(0x76);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x40); //5
                   Soft_I2C_Write(0x40);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   if (PARAMETR != 0x00) Soft_I2C_Write(0x01);
                      else Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00); //10
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Stop();                               // Issue stop signal 4

                   Soft_I2C_Start();                              // Issue start signal 5
                   Soft_I2C_Write(0x76);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x80);
                   Soft_I2C_Write(0x60); //5
                   Soft_I2C_Write(0x40);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   if (PARAMETR != 0x00) Soft_I2C_Write(0x01);
                      else Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00); //10
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Write(0x00);
                   Soft_I2C_Stop();                               // Issue stop signal 5

}/********************   ********************************* */

void main()
{
/*initialization of ports*/
     CMCON = 0xFF;                               //  
     PORTA = 0x00;
     TRISA = 0x02;                               //RA1 - input
     OPTION_REG = 0x7F;                          //pull-up resistors on
     PORTB = 0xFF;
     TRISB = 0xFF;                               //all RB is inputs
     CONTRAST = 0x9A;
     CONTR_VAL = 0x41;
     MODE =  0x00;
     CORR = 0x00;
     MEAS_TEMP = 0x01;                           //    
     PARAMETR = 0x00;
     INTE_bit = 1;
     GIE_bit = 1;

/*initialization I2C*/
      Soft_I2C_Init();
      delay_ms(300);  //!!!    100 
/* ******************************************************************************** */
/* *********************************  ISL1208***************************** */
/* ********************************* ***************************** */
/* ******************************************************************************** */
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xDE);           // Address ISL1208
  Soft_I2C_Write(0x07);           //address of  register (0x00)
  Soft_I2C_Start();               // Issue repeated start signal
  Soft_I2C_Write(0xDF);           // Address ISL1208 for reading R/W=1
  STAT = Soft_I2C_Read(0);        //   STATUS
  Soft_I2C_Stop();                // Issue stop signal

  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xDE);           // Address ISL1208
  Soft_I2C_Write(0x07);
  Soft_I2C_Write(0x10);
  Soft_I2C_Stop();                // Issue stop signal
     
  if ((STAT&0x01)==0x01)
     {MN = 0x00; HR = 0x12; DW = 0x06; DT = 0x01; MO = 0x01; YR = 0x12;
     PARAMETR = 0x09;                            //   ,      
     FLAG_EXIT = 0x01;
     }
  

/* *******************      AD7414-0*************** */
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x92);           // Address AD7414-0
  Soft_I2C_Write(0x01);           //  Configuration
  Soft_I2C_Write(0xF8);           //     0F8
  Soft_I2C_Stop();                // Issue stop signal

  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0x90);           // Address 
  Soft_I2C_Write(0x01);           //  Configuration
  Soft_I2C_Write(0x01);           //     001-  Shutdown
  Soft_I2C_Stop();                // Issue stop signal

/* ************************* *************************/
  while(1)
  {RBIE_bit = 0;
  
  if (FLAG_EXIT == 0x01)
     {if (PARAMETR == 0x0B)
         {PARAMETR = 0x00;
         Soft_I2C_Start();               // Issue start signal
         Soft_I2C_Write(0xDE);           // Address ISL1208
         Soft_I2C_Write(0x00);
         Soft_I2C_Write(0x00);           //   
         Soft_I2C_Stop();                // Issue stop signal;}
         }
     Write_Time(MN, HR, DW, DT, MO, YR); //   ,    RTC
                                         //     
     MEAS_TEMP = 0x01;     //  
     Puls = 0x00;
     FLAG_EXIT = 0x00;
     }
/* ******************************************************************************** */
/* *********************************  ISL1208***************************** */
/* ******************************************************************************** */

  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xDE);           // Address ISL1208
  Soft_I2C_Write(0x00);           //address of  register (0x00)
  Soft_I2C_Start();               // Issue repeated start signal
  Soft_I2C_Write(0xDF);           // Address ISL1208 for reading R/W=1
  
  if (PARAMETR == 0x00)           //   ,      
     {SC = Soft_I2C_Read(1);         // Read seconds byte
     MN = Soft_I2C_Read(1);          // Read minutes byte
     HR = Soft_I2C_Read(1)&0x7F;     // Read hours byte
     DT = Soft_I2C_Read(1);
     MO = Soft_I2C_Read(1);          // Read month byte
     YR = Soft_I2C_Read(1);
     DW = Soft_I2C_Read(0);          // Read year byte
     }
     else SC = Soft_I2C_Read(0);     // Read seconds byte
  Soft_I2C_Stop();                   // Issue stop signal


      SC10 = SC&0xF0;
      MN10 = MN&0xF0;
      HR10 = HR&0xF0;
      DT10 = DT&0xF0;
      YR10 = YR&0xF0;


      asm {
          SWAPF _SC10,1
          SWAPF _MN10,1
          SWAPF _HR10,1
          SWAPF _DT10,1
          SWAPF _YR10,1
          }

      SC1 = SC&0x0F;
      MN1 = MN&0x0F;
      HR1 = HR&0x0F;
      DT1 = DT&0x0F;
      YR1 = YR&0x0F;
      
  switch(MO){
             case 0x01: MO1 = 'J'; MO2 = 'a'; MO3 = 'n'; break;
             case 0x02: MO1 = 'F'; MO2 = 'e'; MO3 = 'b'; break;
             case 0x03: MO1 = 'M'; MO2 = 'a'; MO3 = 'r'; break;
             case 0x04: MO1 = 'A'; MO2 = 'p'; MO3 = 'r'; break;
             case 0x05: MO1 = 'M'; MO2 = 'a'; MO3 = 'y'; break;
             case 0x06: MO1 = 'J'; MO2 = 'u'; MO3 = 'n'; break;
             case 0x07: MO1 = 'J'; MO2 = 'u'; MO3 = 'l'; break;
             case 0x08: MO1 = 'A'; MO2 = 'u'; MO3 = 'g'; break;
             case 0x09: MO1 = 'S'; MO2 = 'e'; MO3 = 'p'; break;
             case 0x10: MO1 = 'O'; MO2 = 'c'; MO3 = 't'; break;
             case 0x11: MO1 = 'N'; MO2 = 'o'; MO3 = 'v'; break;
             case 0x12: MO1 = 'D'; MO2 = 'e'; MO3 = 'c';
             }

  switch(DW){
            case 0x00: DW1 = 0x4D;DW2 = 0x4F; DW3 = 0x4E;break;   //MON
            case 0x01: DW1 = 0x54;DW2 = 0x55; DW3 = 0x45;break;   //TUE
            case 0x02: DW1 = 'W';DW2 = 'E'; DW3 = 'D';break;      //WED
            case 0x03: DW1 = 0x54;DW2 = 0x48; DW3 = 0x55;break;   //THU
            case 0x04: DW1 = 0x46;DW2 = 0x52; DW3 = 0x49;break;   //FRI
            case 0x05: DW1 = 0x53;DW2 = 0x41; DW3 = 0x54;break;   //SAT
            case 0x06: DW1 = 0x53;DW2 = 0x55; DW3 = 0x4E;         //SUN
            }

   if (MEAS_TEMP == 0x01)            /*********** */
      {Soft_I2C_Start();              // Issue start signal
      Soft_I2C_Write(0x92);           // Address AD7414-0
      Soft_I2C_Write(0x01);           //  Configuration
      Soft_I2C_Write(0x7C);           //     000
      Soft_I2C_Stop();                // Issue stop signal
      delay_ms(100);
      
/* **************************   ************************* */
      Soft_I2C_Start();               // Issue start signal
      Soft_I2C_Write(0x92);           // Address AD7414-0
      Soft_I2C_Write(0x00);           //  
      Soft_I2C_Start();               // Issue repeated start signal
      Soft_I2C_Write(0x93);           // Address AD7414-0
      TEMP1 = Soft_I2C_Read(1);       //   
      Soft_I2C_Stop();                // Issue stop signal
      TEMP1 = TEMP1 + CORR;
      if (TEMP1 > 0) ZNAK = '+'; else if (TEMP1 == 0) ZNAK = 0x20; else {ZNAK = '-'; TEMP1 = 0x00 - TEMP1;}
      T10 = 0x00;
      while (TEMP1 > 9) {TEMP1 = TEMP1 - 10; ++T10;}       //    
      T1 = TEMP1;
      MEAS_TEMP = 0x00;        //    1 
      
      Soft_I2C_Start();               // Issue start signal
      Soft_I2C_Write(0x92);           // Address AD7414-0
      Soft_I2C_Write(0x01);           //  Configuration
      Soft_I2C_Write(0xF8);           //     0F8-  Shutdown
      Soft_I2C_Stop();                // Issue stop signal
      }

  IndicatorSet();     //  

        RBIE_bit = 1;
        asm {
            SLEEP
            NOP
            }
      }
}